-- Tests poslib implementation
-- Test Sequence
-- This file loads functions from "ptf.lua"
--
-- 1997 Claudio Terra
-- PUC-Rio

print ("\n\nLua POSIX Library Test Program")

-- sysconf, poslibvers
print ("This is ".._VERSION..", POSIX Library "..poslibvers()..", POSIX "..sysconf("version")..".\n")
print("System information given by uname:")
-- uname
print(uname("%s release %r, version %v.\nNodename '%n', machine is '%m'.\n"))

local a = clock()
print("Loading aux functions")
assert(dofile("ptf.lua") ~= nil)
local thePath = getcwd()

print("Testing pathconf")
TestPathconf2(thePath)
TestPathconf()

print("Testing stat")
TestStat()

print("Testing umask")
TestUmask()

print("Testing getenv")
TestGetenv()

print("Testing lock")
TestLock()

print("Testing mkdir")
TestMkdir()

print("Testing mode changes (chmod, stat, access)")
TestModes()

print("Testing utime")
TestUtime()

print("Testing getpasswd")
TestGetpasswd()

print("Testing getgroup")
TestGetgroup()

print("Testing getprocessid")
TestGetprocessid()

print("Testing currdate and sleep")
local first=currdate()
TestDateTable(first)
print(date("%c", first))
print("Sleeping 5 seconds...")
assert(sleep(5) == 0)
local second=currdate()
print(date("%c", second))
if first.sec >= 54 then second.sec = second.sec + 60 end
assert(first.sec + 5 == second.sec)

print("\nCPU Time used: "..clock() - a)
print("Test is complete.")
