-- Tests poslib implementation
-- Test Sequence
-- This file loads functions from "ptf.lua"
--
-- 1997 Claudio Terra
-- PUC-Rio

print ("\n\nLua POSIX Library Test Program")
print ("\n\These tests must run with root privileges.")


function TestSetuid()
	--edit the following line
	local loginname="isabel"

	local euid, uid;
	
	-- getting original ids
	euid=getprocessid("euid")
	uid=getprocessid("uid")
	assert(uid~=nil)
	
	local a,b = setuid(loginname);
	if a==nil then print ("setuid failed! - "..b); return end;
	local t=getpasswd(getprocessid("euid"))
	print("EUID changed from "..euid.." to "..t.uid..".")
	print("User name is now "..t.name..".")
	print("Real user ids: original="..uid.."; now="..getprocessid("uid")..".")
	local a,b = setuid(euid);
	if a==nil then print ("setuid failed! - "..b); return end;
	print("Effective UID is now back to original value.")

end

function TestSetgid()
	--edit the following line
	local groupname="other"

	local egid, gid;
	
	-- getting original ids
	egid=getprocessid("egid")
	gid=getprocessid("gid")
	
	assert(gid ~=nil)
	
	local a,b = setgid(groupname);
	if a==nil then print ("setgid failed! - "..b); return end;
	local t=getgroup(getprocessid("egid"))
	print("EGID changed from "..egid.." to "..t.gid..".")
	print("Group name is now "..t.name..".")
	print("Real group ids: original="..gid.."; now="..getprocessid("gid")..".")
	local a,b = setgid(egid);
	if a==nil then print ("setgid failed! - "..b); return end;
	print("Effective GID is now back to original value.")

end

-- sysconf, poslibvers
print ("This is ".._VERSION..", POSIX Library "..poslibvers()..", POSIX "..sysconf("version")..".\n")

local t = getpasswd(getprocessid("uid"))

if t.uid ~= 0 then -- root is uid 0
	print ("You're not under UID 0 (root)! Happy crash-landing...")
end



print("Testing set-user-id.")
TestSetuid();

print("\nTesting set-group-id.")
TestSetgid();

print("Test is complete.")
